<xsl:stylesheet version="2.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" indent="yes"/>

<xsl:key name="ndkey" match="nd" use="@ref"/>

<xsl:variable name="ndsG">
	<xsl:copy-of select="/osm/way/nd[(position() = 1) or (position() = last()) or (count(key('ndkey', @ref)) > 1)]"/>
</xsl:variable>

<xsl:template match="/osm">
	<xsl:copy>
		<xsl:copy-of select="@*"/>
		<xsl:apply-templates select="way"/>
		<xsl:copy-of select="node[key('ndkey',@id,$ndsG)]"/>
		<!--
		<xsl:copy-of select="relation"/>
		-->
	</xsl:copy>
</xsl:template>

<xsl:template match="way">
	<xsl:copy>
		<xsl:copy-of select="@*"/>
		<xsl:copy-of select="nd[key('ndkey',@ref,$ndsG)]"/>
		<xsl:copy-of select="tag"/>
	</xsl:copy>
</xsl:template>

</xsl:stylesheet>
